# Generated by Django 2.1.4 on 2020-06-15 09:06

from django.db import migrations


def forward(apps, se):
    """
    Link default typologies with all existing documents
    """
    Document = apps.get_model('core', 'Document')
    BlockType = apps.get_model('core', 'BlockType')
    LineType = apps.get_model('core', 'LineType')

    data = []
    for typology in BlockType.objects.filter(default=True):
        for doc in Document.objects.all():
            data.append(Document.valid_block_types.through(document=doc, blocktype=typology))
    Document.valid_block_types.through.objects.bulk_create(data)

    data = []
    for typology in LineType.objects.filter(default=True):
        for doc in Document.objects.all():
            data.append(Document.valid_line_types.through(document=doc, linetype=typology))
    Document.valid_line_types.through.objects.bulk_create(data)


def backward(apps, se):
    Document = apps.get_model('core', 'Document')

    Document.valid_block_types.through.objects.all().delete()
    Document.valid_line_types.through.objects.all().delete()


class Migration(migrations.Migration):

    dependencies = [
        ('core', '0039_create_default_typologies'),
    ]

    operations = [
        migrations.RunPython(forward, backward),
    ]
